#ifndef XRS_Graphic_H
#define XRS_Graphic_H
	
#include <XRS/graphic.h>
#include <XRS/f_dialog.h>

//*************** class Graphic_Window ̒` *********************

class Graphic_Window;

struct Graphic_Window_Pc{  //1 argument(char*) manipurator
    void  (*fp)(Graphic_Window&,char*);
    char*  arg;
    Graphic_Window_Pc(void (*f)(Graphic_Window&,char*),char* a){fp=f;arg=a;}
};
							  

struct Graphic_Window_di{   //2 argument(double,int) manipurator
    void  (*fp)(Graphic_Window&,double,int);
    double x;
    int   arg;
    Graphic_Window_di(void (*f)(Graphic_Window&,double,int),double y,int a){
                        fp=f;  x=y;  arg=a;}
};


struct Graphic_Window_A_Uli{ //2 argument(unsigned long[],int) manipurator
    void  (*fp)(Graphic_Window&,unsigned long *,int);
    unsigned long *x;
    int   arg;
    Graphic_Window_A_Uli(void (*f)(Graphic_Window&,unsigned long *,int)
             ,unsigned long y[],int a){ fp=f;  x=y;  arg=a;}
};


class Graphic_Window:public graphic_window{
 public:
   Graphic_Window(window &W,int w=0,int h=0,int ms=0,
         int i=0,int j=0,int bw=-1):
		 graphic_window(W,w,h,ms,i,j,bw){}
   Graphic_Window(int w=0,int h=0,int ms=0):
         graphic_window(w,h,ms){}
		 
   Graphic_Window& geometry(int w=0,int h=0,int ms=0,int i=-1,int j=-1)
        { resize(w,h,ms); move(i,j);  return *this; }

   f_dialog*    add(void (*)(int));		
		
   //-------- << Zq̒` ---------
   Graphic_Window& operator<<(char *name)  {   title(name); return *this; }
   Graphic_Window& operator<<(void (*f)(int)){   add(f);    return *this; }
   Graphic_Window& operator<<(double (*f)(double))
                                       { color_function(f);  return *this; }

   //--------- }js[^[ MEMORY ̒` --------
   friend Graphic_Window& operator<<(Graphic_Window&,
                                     Graphic_Window&(*)(Graphic_Window &));
   friend Graphic_Window& MEMORY(Graphic_Window&);

   //--------- }js[^[ MONO,PHASE ̒` --------
   friend Graphic_Window& operator<<(Graphic_Window&,Graphic_Window_di);
   friend void setMONO(Graphic_Window&,double,int);
   friend void setPHASE(Graphic_Window&,double,int);

   //--------- }js[^[ COLOR ̒` --------
   friend Graphic_Window& operator<<(Graphic_Window&,Graphic_Window_Pc);
   friend void setCOLOR(Graphic_Window&,char*);

   friend Graphic_Window& operator<<(Graphic_Window&,Graphic_Window_A_Uli);
   friend void setCOLOR(Graphic_Window&,unsigned long[],int);   
};


inline Graphic_Window& operator<<(Graphic_Window &s,
   Graphic_Window& (*f)(Graphic_Window &)){return f(s);}

inline Graphic_Window& MEMORY(Graphic_Window &s)
   {  if(!s.free_memory()) s.memory();  return s; }
   
inline Graphic_Window& operator<<(Graphic_Window &s,Graphic_Window_di m)
   { m.fp(s,m.x,m.arg); return s;}

inline void setMONO(Graphic_Window& s,double x,int n){ s.monotone(x,n); }
inline Graphic_Window_di MONO(double x=-1,int n=0)
{    return Graphic_Window_di(setMONO,x,n); } 

inline void setPHASE(Graphic_Window& s,double x,int n){ s.phasetone(x,n); }
inline Graphic_Window_di PHASE(double x=-1,int n=0)
{    return Graphic_Window_di(setPHASE,x,n); }

inline Graphic_Window& operator<<(Graphic_Window& s,Graphic_Window_Pc m)
   {m.fp(s,m.arg); return s;}

inline void setCOLOR(Graphic_Window& s,char* file){ s.color_resource(file); }
inline Graphic_Window_Pc COLOR(char* c=NULL)
{    return Graphic_Window_Pc(setCOLOR,c); }

inline Graphic_Window& operator<<(Graphic_Window& s,Graphic_Window_A_Uli m)
   {m.fp(s,m.x,m.arg); return s;}

inline void setCOLOR(Graphic_Window& s,unsigned long c[],int n)
   {s.color_pixel(c,n);}
inline Graphic_Window_A_Uli COLOR(unsigned long c[],int n)
{    return Graphic_Window_A_Uli(setCOLOR,c,n); }

f_dialog* Graphic_Window::add(void (*f)(int)){
     f_dialog *pp=new f_dialog(*this,f); 
     pp->resize(mesh_size()*width(),mesh_size()*height());
     return pp;
}
#endif
